<? 
include_once("include/config.inc");
include_once("include/functions.php");

$type = strtolower($_GET["type"]);

if (strcmp($type, "signal") == 0)
  $opts = graph_signal();
else if (strcmp($type, "latency") == 0)
  $opts = graph_latency();
else if (strcmp($type, "cpuload") == 0)
  $opts = graph_cpuload();
else if (strcmp($type, "uptime") == 0)
  $opts = graph_uptime();
else if (strcmp($type, "traffic") == 0)
  $opts = graph_traffic();
else
  exit;

print_graph($opts);

function graph_signal()
{
    global $phprrd, $rrd_directory;
    $id = $_GET["id"];
    $ip = $_GET["description"];
    $interface = $_GET["interface"];
    $interface_printable = convert_alphabet_rev($interface);
    $interface_printable = strtr($interface_printable, array ("'" => "", "\"" => ""));
    $mac = $_GET["mac"];
    $mac2 = str_replace(":","\:",$mac);
     
    $timestamp = isset($_GET["timestamp"]) ? $_GET["timestamp"] : "now-1d";
      
    $fname = $rrd_directory."rosinfo-signal-$id-$interface-$mac2.rrd";
    $quote = "";
    if (!$phprrd)
	$quote = "\"";

    $opts = array(
      "--imgformat=PNG",
      "-e now",
      "-s $timestamp",
      "-t ".$quote."Signal - $ip - $interface_printable - $mac".$quote,
      "-r",
      "-b 1000",
      "-h 110",
      "-w 430",
      "-u -40",
      "-l -100",
      "-v dBm",
      "--slope-mode",
      "-cBACK#ffffff",
      "-cSHADEA#DCDCDC",
      "-cSHADEB#DCDCDC",
      "DEF:signal=".$quote."$fname".$quote.":Signal:AVERAGE",
      "DEF:signal_min=".$quote."$fname".$quote.":Signal:MIN",
      "DEF:signal_max=".$quote."$fname".$quote.":Signal:MAX",
      "AREA:signal#dcdcdc::",


      "LINE3:signal#000000::",
      "AREA:signal#f10000:".$quote."Wireless Signal".'\n'.$quote.":STACK",
//      "AREA:signal#dcdcdc::",
//      "AREA:signal_max#f1ff00::STACK",
      "LINE1:signal_min#888888::",
      "LINE1:signal_max#888888::",

      "GPRINT:signal:LAST:".$quote."Current\:%4.0lfdBm".$quote,
      "GPRINT:signal:MIN:".$quote."Minimum\:%4.0lfdBm".$quote,
      "GPRINT:signal:AVERAGE:".$quote."Average\:%4.0lfdBm".$quote,
      "GPRINT:signal:MAX:".$quote."Maximum\:%4.0lfdBm".$quote,
      "HRULE:-90#aaaaaa:",
      "HRULE:-80#aaaaaa:",
      "HRULE:-70#666666:",
      "HRULE:-60#aaaaaa:",
      "HRULE:-50#aaaaaa:",
      "HRULE:-40#aaaaaa:"
    );
    return $opts;
}

function graph_latency()
{
  global $phprrd, $rrd_directory;
  $ip = $_GET["description"];
  $id = $_GET["id"];

  $timestamp = isset($_GET["timestamp"]) ? $_GET["timestamp"] : "now-1d";  
  
  $fname = $rrd_directory."rosinfo-system-$id.rrd";
  $quote = "";
  if (!$phprrd)
    $quote = "\"";
  
  $opts = array(
    "--imgformat=PNG",
    "-e now",
    "-s $timestamp",
    "-t ".$quote."Latency - $ip".$quote,
    "-r",
    "-b 1000",
    "-h 110",
    "-w 430",
    "-l 0",
    "-v miliseconds",
    "--slope-mode",
    "-cBACK#ffffff",
    "-cSHADEA#DCDCDC",
    "-cSHADEB#DCDCDC",
    "DEF:AVG_Ping=".$quote.$fname.$quote.":Ping:AVERAGE",
    "DEF:MAX_Ping=".$quote.$fname.$quote.":Ping:MAX",
    "DEF:MIN_Ping=".$quote.$fname.$quote.":Ping:MIN",
    
    "AREA:MAX_Ping#c0f080::",
    "AREA:AVG_Ping#a0f060::",
    
    //"LINE1:AVG_Ping#000000::",
    "GPRINT:MAX_Ping:LAST:".$quote."Current\:%5.2lfms".$quote,
    "GPRINT:MIN_Ping:MIN:".$quote."Minimum\:%5.2lfms".$quote,
    "GPRINT:AVG_Ping:AVERAGE:".$quote."Average\:%5.2lfms".$quote,
    "GPRINT:MAX_Ping:MAX:".$quote."Maximum\:%5.2lfms".$quote,
  );
  return $opts;
}

function graph_cpuload()
{
  global $phprrd, $rrd_directory;
  $ip = $_GET["description"];
  $id = $_GET["id"];
  
  $timestamp = isset($_GET["timestamp"]) ? $_GET["timestamp"] : "now-1d";
  
  $fname = $rrd_directory."rosinfo-system-$id.rrd";
  $quote = "";
  if (!$phprrd)
    $quote = "\"";
    
  $opts = array(
    "--imgformat=PNG",
    "-e now",
    "-s $timestamp",
    "-t ".$quote."CPU Load - $ip".$quote,
    "-r",
    "-b 1000",
    "-h 110",
    "-w 430",
    "-l 0",
    "-v percent",
    "--slope-mode",
    "-cBACK#ffffff",
    "-cSHADEA#DCDCDC",
    "-cSHADEB#DCDCDC",
    "DEF:MAX_CPULoad=".$quote.$fname.$quote.":CPULoad:MAX",
    "DEF:AVG_CPULoad=".$quote.$fname.$quote.":CPULoad:AVERAGE",
    "DEF:MIN_CPULoad=".$quote.$fname.$quote.":CPULoad:MIN",
    
    "AREA:MAX_CPULoad#f1aaaa::",
  
    "AREA:AVG_CPULoad#f10000::",
    
    //"LINE1:AVG_CPULoad#000000::",
    //"LINE1:MAX_CPULoad#000000::",
    "GPRINT:MAX_CPULoad:LAST:".$quote."Current\:%5.0lf%%".$quote,
    "GPRINT:MIN_CPULoad:MIN:".$quote."Minimum\:%5.0lf%%".$quote,
    "GPRINT:AVG_CPULoad:AVERAGE:".$quote."Average\:%5.0lf%%".$quote,
    "GPRINT:MAX_CPULoad:MAX:".$quote."Maximum\:%5.0lf%%".$quote,
  );
  return $opts;
}

function graph_uptime()
{
  global $phprrd, $rrd_directory;
  $ip = $_GET["description"];
  $id = $_GET["id"];
  
  $timestamp = isset($_GET["timestamp"]) ? $_GET["timestamp"] : "now-1d";
  
  $fname = $rrd_directory."rosinfo-system-$id.rrd";
  $quote = "";
  if (!$phprrd)
    $quote = "\"";
    
  $opts = array(
    "--imgformat=PNG",
    "-e now",
    "-s $timestamp",
    "-t ".$quote."Uptime - $ip".$quote,
    "-r",
    "-b 1000",
    "-h 110",
    "-w 430",
    "-l 0",
    "-v days",
    "--slope-mode",
    "-cBACK#ffffff",
    "-cSHADEA#DCDCDC",
    "-cSHADEB#DCDCDC",
    "DEF:Uptime=".$quote.$fname.$quote.":Uptime:AVERAGE",
    "CDEF:UptimeH=Uptime,86400,/",
    "AREA:UptimeH#1111cc::",
    "LINE1:UptimeH#000000::",
    "GPRINT:UptimeH:LAST:".$quote."Current\:%3.1lf days".$quote,
    #"GPRINT:UptimeH:MIN:".$quote."Min\:%3.1lf days".$quote,
    #"GPRINT:UptimeH:AVERAGE:".$quote."Avg\:%3.1lf days".$quote,
    #"GPRINT:UptimeH:MAX:".$quote."Max\:%3.1lf days".$quote,
  );
  return $opts;
}

function graph_traffic()
{
    global $phprrd, $rrd_directory;
    $id = $_GET["id"];
    $description = $_GET["description"];
    $interface = $_GET["interface"];
    $interface_printable = convert_alphabet_rev($interface);
    $interface_printable = strtr($interface_printable, array ("'" => "", "\"" => ""));
     
    $timestamp = isset($_GET["timestamp"]) ? $_GET["timestamp"] : "now-1d";
      
    $fname = $rrd_directory."rosinfo-traffic-$id-$interface.rrd";
    $quote = "";
    if (!$phprrd)
	$quote = "\"";

    $opts = array(
      "--imgformat=PNG",
      "-e now",
      "-s $timestamp",
      "-t ".$quote."Traffic - $description - $interface_printable".$quote,
      "-r",
      "-b 1000",
      "-h 110",
      "-w 430",
      //"-u -40",
      //"-l -100",
      "-v Bytes/sec",
      "--slope-mode",
      "-cBACK#ffffff",
      "-cSHADEA#DCDCDC",
      "-cSHADEB#DCDCDC",
      
      "DEF:MAX_traffic_in=".$quote."$fname".$quote.":traffic_in:MAX",
      "DEF:MAX_traffic_out=".$quote."$fname".$quote.":traffic_out:MAX",
      "CDEF:MAX_traffic_total=MAX_traffic_out,MAX_traffic_in,+",
      "CDEF:MAX_traffic_in_kB=MAX_traffic_in,1024,/",
      "CDEF:MAX_traffic_out_kB=MAX_traffic_out,1024,/",
      "CDEF:MAX_traffic_total_kB=MAX_traffic_total,1024,/",
      
      "DEF:AVG_traffic_in=".$quote."$fname".$quote.":traffic_in:AVERAGE",
      "DEF:AVG_traffic_out=".$quote."$fname".$quote.":traffic_out:AVERAGE",
      "CDEF:AVG_traffic_total=AVG_traffic_out,AVG_traffic_in,+",
      "CDEF:AVG_traffic_in_kB=AVG_traffic_in,1024,/",
      "CDEF:AVG_traffic_out_kB=AVG_traffic_out,1024,/",
      "CDEF:AVG_traffic_total_kB=AVG_traffic_total,1024,/",           

      /*"AREA:MAX_traffic_total#ffaaaa:".$quote."Maximum total\:    ".$quote.":",
      
      "AREA:MAX_traffic_out#aaaacc:".$quote."Maximum outgoing\: ".$quote.":",
      
      "AREA:MAX_traffic_in#aaccaa:".$quote."Maximum incomming\:".$quote.":",*/
      "AREA:MAX_traffic_total#ffaaaa::",
      
      "AREA:MAX_traffic_out#aaaacc::",
      
      "AREA:MAX_traffic_in#aaccaa::",

      "AREA:AVG_traffic_total#ff1111:".$quote."Average total\:    ".$quote.":",
      "GPRINT:AVG_traffic_total_kB:AVERAGE:".$quote."%5.0lf kiByte/sec".''.$quote,
      "GPRINT:MAX_traffic_total_kB:MAX:".$quote."    Maximum\:%5.0lf kiByte/sec".'\n'.$quote,
      
      "AREA:AVG_traffic_out#1111cc:".$quote."Average outgoing\: ".$quote.":",
      "GPRINT:AVG_traffic_out_kB:AVERAGE:".$quote."%5.0lf kiByte/sec".''.$quote,
      "GPRINT:MAX_traffic_out_kB:MAX:".$quote."    Maximum\:%5.0lf kiByte/sec".'\n'.$quote,
      
      "AREA:AVG_traffic_in#11cc11:".$quote."Average incomming\:".$quote.":",
      "GPRINT:AVG_traffic_in_kB:AVERAGE:".$quote."%5.0lf kiByte/sec".''.$quote,
      "GPRINT:MAX_traffic_in_kB:MAX:".$quote."    Maximum\:%5.0lf kiByte/sec".'\n'.$quote,
      "LINE1:AVG_traffic_out#1111cc::"           
    );
    return $opts;
}

function print_graph($opts)
{
    global $phprrd, $rrdtool;
    if ($phprrd)
    {
      $graph_file = tempnam($rrd_directory."tmp","rosinfo");
      $ret = rrd_graph($graph_file, $opts, count($opts)); 
      if ($ret == 0)
      {
        $err = rrd_error();
        echo ".Create error: $err\n.";
        return;
      }
    }
    header("Content-Type: image/png");
    if ($phprrd)
      header("Content-Length: ". filesize($graph_file));
    header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
    header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
    header("Cache-Control: no-cache, must-revalidate");
    header("Pragma: no-cache");
    
    // dump the graph
    if ($phprrd)
    {
      $fp = fopen($graph_file,"rb");
      fpassthru($fp);
      fclose($fp);
      unlink($graph_file);
    }
    else
    {
      $cmd = "$rrdtool graph - ". implode(" ", $opts);
      //echo $cmd; 
      echo shell_exec($cmd);
    }
}
?>
